/***************************************************************************
                          textfontselect.h  -  description
                             -------------------
    begin                : Tue Sep 2 2003
    copyright            : (C) 2003-2011 Arahne, d.o.o.
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TEXTFONTSELECT_H
#define TEXTFONTSELECT_H

#include <qdialog.h>
#include <qptrlist.h>

#define HOFF      5
  
class  QListBox;
class  QComboBox;
class  QFontDialogPrivate;
  
class TextFontSelect : public QDialog  {
  Q_OBJECT
public: 
  TextFontSelect( QWidget* parent=0, const char* name=0, bool modal=FALSE, WFlags f=0 );
  ~TextFontSelect();

public:
    static QFont getFont( bool *ok, const QFont &def,
			  QWidget* parent=0, const char* name=0);
    static QFont getFont( bool *ok, QWidget* parent=0, const char* name=0);

    void showDlg();
    
    QStringList text();
    QFont font();
    QRect textSize(bool useTab, QPtrList<QSize>& sizeTab);
    bool isBGTransparent() {return transBg;}
    int aligning() const;

private:    

    void parseFontName(const QString &name, QString &foundry, QString &family);
    void setFont( const QFont &font );
    int getMaxLen(QStringList &strL);
    bool isRawNameCorrect(QString rname, QString &newFont);

signals:
    void fontSelected( const QFont &font );
    void fontHighlighted( const QFont &font );
    void insertBtnClicked();
    void closeSig();

protected:
    bool eventFilter( QObject *, QEvent * );    

    QListBox * familyListBox() const;
    virtual void updateFamilies();

    QListBox * styleListBox() const;
    virtual void updateStyles();

    QListBox * sizeListBox() const;
    virtual void updateSizes();

    QComboBox * scriptCombo() const;
    virtual void updateScripts();

#if 0
    QString family() const;
    QString script() const;
    QString style() const;
    QString size() const;
#endif

  void closeEvent(QCloseEvent *e);

protected slots:
    void sizeChanged( const QString &);
    void bgColorClicked(int which);

private slots:
    void familyHighlighted( const QString &);
    void familyHighlighted( int );
    void scriptHighlighted( const QString &);
    void scriptHighlighted( int );
    void styleHighlighted( const QString &);
    void sizeHighlighted( const QString &);
    void updateSample();
    void emitSelectedFont();
    void setSizeLabel();
    void leftPressed();
    void rightPressed();
    void centerPressed();
    void fillPressed();

private:
    static QFont getFont( bool *ok, const QFont *def, QWidget* parent=0, const char* name=0);

    QFontDialogPrivate * d;
    friend class QFontDialogPrivate;
    bool transBg;
    int lastFamily;
    QPtrList<QSize> dummy;
    int align;
};

#endif
