/***************************************************************************
                          dialogGuessWeave.h  -  description
                             -------------------
    begin                : Tue Mar 23 2004
    copyright            : (C) 2004-2011 Arahne, d.o.o.
    email                : arahne@arahne.si
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DIALOGGUESSWEAVE_H
#define DIALOGGUESSWEAVE_H

#include "dialog_ui_guessWeave.h"

class ApaintDoc;
class Layer;
class ApaintImage;

class GuessWeaveDialog: public GuessWeaveDialogUI
{
 Q_OBJECT
public:
  GuessWeaveDialog(QWidget *parent, ApaintDoc *docp, const char *name);
  ~GuessWeaveDialog();

  void showDlg();
signals:
  void sendEvents(bool enable);
  
protected:
  void closeEvent(QCloseEvent *e);
  void hideEvent(QHideEvent *e);
  
protected slots:
 void closeDlg();
 void doPreview();
 void guessWeaveOK();
 void widHeiChanged(int val);
 void layerChangedSlot(Layer* layer);
    
private:
 void guessWeave(ApaintImage &img, int &gx, int &gy);
 void guessPreview();
 void doUndo();
 void setupDlg();
 void doOnClose();

 
 ApaintDoc *doc;
 int minSquareX, minSquareY;
 bool previewMode, dlgIsOn;
};

#endif
