/***************************************************************************
                          multiplepastedlg.h  -  description
                             -------------------
    begin                : Fri Aug 29 2003
    copyright            : (C) 2003-2011 Arahne, d.o.o.
    email                : arahne@arahne.si
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef MULTIPLEPASTEDLG_H
#define MULTIPLEPASTEDLG_H

#include <dialog_ui_layerRepeat.h>
#include "apaintdoc.h"
#include <qspinbox.h>

enum RepeatMode{Brick, HorMove, VertMove};
enum DistanceMode{ Alignment, Relativ};
enum AlignmentModeHor {LeftHor, MidHor, RightHor};
enum AlignmentModeVert {TopVert, MidVert, BottomVert};

    
class MultiplePasteDlg : public MultiplePasteDialogUI  {
  Q_OBJECT
public: 
	 MultiplePasteDlg(QWidget *parent, const char *name, bool modal, ApaintDoc *pdoc);
	~MultiplePasteDlg();

   void showDlg();

   int getPasteTimesX(){ return sbPasteTimesWid->value();}
   int getPasteTimesY(){ return sbPasteTimesHei->value();}
   int getOffsetX() {return sbOffsetHor->value();}
   int getOffsetY() {return sbOffsetVert->value();}
   int getDistanceX() {return sbDistanceHor->value();}
   int getDistanceY() {return sbDistanceVert->value();}
      
public slots:
  void setRepMode(int mode);
  void setDistanceMode(int mode);
  void setAlignHorMode(int mode);
  void setAlignVertMode(int mode);
  void distHorChanged(int val);
  void distVertChanged(int val);
  void btnOkClicked();
  void btnPreviewClicked();
  void btnCloseClicked();
  /*indx val in combo box*/
  void setOffsetX(int indx);
  void setOffsetY(int indx);
  void layerChangedSlot(Layer *layer);

protected slots:
  void pasteTimes(int val);
  void offsetChanged(int val);
  void doUpdate();
  
protected:
  void setDistanceHor(int val);
  void setDistanceVert(int val);
  void setDistanceMinMax();
  void doAction();
  void doUndo(bool makeUndo);
  void closeEvent(QCloseEvent *e);
  void hideEvent(QHideEvent *e);
  
private:
  bool getData(Layer *layer);
  void setupDlg();
  void doRestore();
  void doOnClose();
  
  ApaintDoc *doc;
  LayerDrag *data;
  ApaintImage imgData;
  QImage maskData;
  RepeatMode rmode;
  DistanceMode dmode;
  AlignmentModeHor alignHorMode;
  AlignmentModeVert alignVertMode;
  int distanceWid, distanceHei;
  int offsetWid, offsetHei;
  bool didPaste;
  bool validLayer;
  bool dlgOn;
  bool previewOn;
};

#endif
