/***************************************************************************
                          bsplinetool.h  -  description
                             -------------------
    begin                : Thu Dec 4 2003
    copyright            : (C) 2003-2011 Arahne, d.o.o.
    email                : arahne@arahne.si
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef BSPLINETOOL_H
#define BSPLINETOOL_H

#include <toolbase.h>
#include <qpointarray.h>

class DrawInRepeat;  
  
class BSplineTool : public ToolBase  {
  Q_OBJECT
public: 
	BSplineTool(DrawInRepeat *drawp, ToolType type, PropObject *propObj);
	~BSplineTool();

 virtual void mousePressed(QMouseEvent *e, QPainter *pc, QPainter *pi);
 virtual void mouseMoved(QMouseEvent *e, QPainter *pc, QPainter *pi);
 virtual void begin();
 virtual void showCommonProp(bool enable);

private:
  void drawCurve(QPainter *p, bool doRefresh, bool final);
  void calcCurve(QPoint *points, QPointArray &output, int &outputNum, int &outputNumHalf,
                  QPoint *interm1, QPoint *interm2, bool *breakpt);
  void resetState();
  void saveCurve(QPainter *p, bool finish);

  DrawInRepeat *draw;
  bool drawStarted;
  ButtonState btnPressed;
  QPoint *inPts;
  QPoint *im1;
  QPoint *im2;
  bool *bpt;
  QPointArray outPts, halfOutPts;  
  int nPoints, splitPoint, outPtsNum, halfOutPtsNum;

};

#endif
