/***************************************************************************
                          freehandselect.h  -  description
                             -------------------
    begin                : Mon Aug 18 2003
    copyright            : (C) 2003-2011 Arahne, d.o.o.
    email                : arahne@arahne.si
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef FREEHANDSELECT_H
#define FREEHANDSELECT_H

#include <toolbase.h>
#include "apaintdoc.h"

extern bool autoScrollNoButton;

class FreeHandSelect : public ToolBase  {
  Q_OBJECT
public: 
	FreeHandSelect(ToolType tooltype, ApaintDoc *docp, PropObject *propObj);
	~FreeHandSelect();

 virtual void mousePressed(QMouseEvent *e, QPainter *pc, QPainter *pi);
 virtual void mouseReleased(QMouseEvent *e, QPainter *pc, QPainter *pi);
 virtual void mouseMoved(QMouseEvent *e, QPainter *pc, QPainter *pi);
 virtual void keyPress(QKeyEvent *e, QPainter *pc, QPainter *pi);
 virtual void beforeRefresh(QPainter *p);
 virtual void afterRefresh(QPainter *p);

 
 void begin();
 void end();

signals:
 void setCursor(QCursor &cur);
 void unsetCursor();

public slots:
 void layerChangedSlot(Layer *layer);

      
private:
  void beginTool();
  void endTool();
  void createLayer();
  void doOp(QPainter *pc, int x, int y);
  void selectOp(QPainter *pc, int x, int y);
  void destroyLayer();
  void drawScaleLine(QPainter *p, int x1, int y1, int x2, int y2);
  bool pointInImage(int x, int y);
  void refreshPoly(QPainter *p);

  bool leftBtnDown, rightBtnDown, drawStarted, layerCreated;
  ApaintDoc *doc;
  SelectState state;
  MousePos mpos;
  int startx, starty, lastx, lasty, firstx, firsty;
  QPtrList<QPoint> ptsList;
  QPointArray borderPts;
  QCursor allCur, mainCur;
};

#endif
