/***************************************************************************
                          simpletransformtool.cpp  -  description
                             -------------------
    begin                : Wed Aug 27 2003
    copyright            : (C) 2003-2011 Arahne, d.o.o.
    email                : arahne@arahne.si
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "toolSimpleTransform.h"
#include <math.h>
#include "toolTransform.h"
#include "apaintBrushList.h"

extern char *getCommonPNG(const char *pixName);

SimpleTransformTool::SimpleTransformTool(ToolType typ, SimpleTransformType transType,  ApaintDoc *docp):ToolBase(typ, 0)
{
 transMode = transType;
 Q_CHECK_PTR(docp);
 doc = docp;
 if (transMode == Mirrorx)
  setToggleBtn(QPixmap(getCommonPNG("flipY")), tr("Mirrory Tool"));
 else if (transMode == Mirrory)
  setToggleBtn(QPixmap(getCommonPNG("flipX")), tr("Mirrorx Tool"));
 else if (transMode == Flip)
  setToggleBtn(QPixmap(getCommonPNG("flipXY")), tr("MirrorFlip Tool"));
 else if (transMode == Explode)
  setToggleBtn(QPixmap(getCommonPNG("arrow-explode")), tr("Explode Tool"));
}

SimpleTransformTool::~SimpleTransformTool()
{
}


void SimpleTransformTool::doAction()
{
 if (doc->isProtectMode())
  return;

 ApaintBrushList *bList = ApaintBrushList::getObject();
 bool useBrush = bList->doShowBrush() || bList->useBrush();
 if (transMode == Mirrorx)
  {
   if (useBrush)
    bList->mirrorVertical();
   else
    {       
     doc->putUndoStack(ChangeLayerMirrorX);
     doc->layerMirrorVertical();
    }
  }
 else if (transMode == Mirrory)
  {
   if (useBrush)
    bList->mirrorHorizontal();
   else
    {
     doc->putUndoStack(ChangeLayerMirrorY);
     doc->layerMirrorHorizontal();
    }
  }
 else if (transMode == Flip)
  {
   if (useBrush)
    bList->mirrorFlip();
   else
    {
     doc->putUndoStack(ChangeLayerFlip);
     doc->layerMirrorFlip();
    }
  }
 else if (transMode == Explode)
  {
   if (useBrush)
    bList->mirrorExplode();
   else
    {
     doc->putUndoStack(ChangeLayerExplode);
     doc->layerMirrorExplode();
    }
  }
}
