/***************************************************************************
                          drawtoolbar.h  -  description
                             -------------------
    begin                : Tue Feb 25 2003
    copyright            : (C) 2003-2011 Arahne, d.o.o.
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DRAWTOOLBAR_H
#define DRAWTOOLBAR_H

#include <qwidget.h>
#include <qptrlist.h>
#include <qpushbutton.h>
#include "toolsctrl.h"
#include "toolbase.h"

class ToolPushButton: public QPushButton
{
  Q_OBJECT
public:

  ToolPushButton(QWidget *parent, const char *name);
  ~ToolPushButton();
signals:
  void doubleClicked();

protected:
  virtual void mouseDoubleClickEvent(QMouseEvent *e);
  
};  
  
class QGridLayout;
class QButtonGroup;
  
class DrawToolBar : public QWidget  {
  Q_OBJECT
public: 
	DrawToolBar(QWidget *parent, const char* name, ToolsCtrl *tc);
	~DrawToolBar();

  void addTool(ToolBase *tool, QString toolTip);
  void endToolAdd();
  void setTool(ToolBase *tool, bool active);
  void resetBtns();
  void enableTool(ToolBase *tool, bool enable);

public slots:
  void enableToolChange(bool enable);
  void changeTool(QObject *sender);
  
protected slots:

  void activateTool(QObject *sender);
  void btnGrpClicked(int i);
  
private:
  void btnChgColor(ToolPushButton *btn, bool active);
  
  int curBtn;
  bool canChangeTool;
  ToolsCtrl *tCtrl;
  QGridLayout *gridLay;
  QPtrList<ToolPushButton> btnList;
  QPtrList<ToolBase> toolList;
  QButtonGroup *btnGrp;
  QColor btnBack;
};

#endif
